from GameClasses import *

# create a Enemy that attacks every k rounds
class PeriodicEnemy(Enemy):

    def __init__(self, name, health, target, weapon, period):
        super().__init__(name, health, target, weapon)
        self.period = period
        self.count = 0

    def play_round(self):
        self.count += 1
        if self.count == self.period:
            super().play_round()
            self.count = 0


# create a weapon that in every k rounds has 1.5 more damage
class PeriodicWeapon(Weapon):

    def __init__(self, name, power, period):
        super().__init__(name, power)
        self.period = period
        self.count = 0

    def use_on(self, entity):
        self.count += 1
        print(self.count, self.period)
        if self.count == self.period:
            entity.damage(1.5 * self.power)
            self.count = 0
            return
        entity.damage(self.power)

#player = Player("The Player", 200, PeriodicWeapon("Periodic fire Sword", 30, 2))
player = Player("The Player", 200, Weapon("Fire Sword", 30))

#PeriodicEnemy("Worm 3-Periodic", 10, player, Weapon("Poison", 10), 3)
Enemy("Worm", 25, player, Weapon("Poison", 10))
Enemy("Worm", 25, player, Weapon("Poison", 10))
Enemy("Worm", 25, player, Weapon("Poison", 10))

Enemy("Skeleton", 70, player, Weapon("Sword", 20))
Enemy("Skeleton", 70, player, Weapon("Sword", 20))
#Enemy("Skeleton", 20, player, PeriodicWeapon("Periodic Sword", 20, 2))


RunGame()
